<?php
/*
TuxBoard forum script
Copyright (C) 2013  Colin Murphy

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

session_start();
require_once("config.php");

if ($_GET["id"])
{
	$id = htmlentities(stripslashes($_GET["id"]), ENT_QUOTES);
	if (is_dir($config["datadir"] . $id))
	{
		$title = file_get_contents($config["datadir"] . $id . "/title.txt");
		$ptitle = $title . " - " . $config["title"];
		include($config["themes"] . $config["theme"] . "/header.html");
		echo "<p class=\"fright\"><a href=\"newtopic.php?id=$id\"><strong>New Topic</strong></a></p><h2>$title</h2>";
		echo "<table class=\"table forums\"><tr class=\"toptr\"><td>Title</td><td>Replies</td><td>Author</td><td>Date</td></tr>";
		
		foreach (glob($config["datadir"] . $id . "/*.html") as $filename) {
			$filename = str_replace(".html", "", $filename);
			$filename = str_replace($config["datadir"] . $id . "/", "", $filename);
			$posttitle = file_get_contents($config["datadir"] . $id . "/$filename" . "_subject.txt");
			$author = file_get_contents($config["datadir"] . $id . "/$filename" . ".author");
			$date = file_get_contents($config["datadir"] . $id . "/$filename" . ".date");
			$replies = file_get_contents($config["datadir"] . $id . "/$filename" . ".replies");
			# check if locked
			if (file_exists($config["datadir"] . $id . "/$filename.lock")) {
				$locked = "<img src=\"" . $config["themes"] . $config["theme"] . "/lock.png\" alt=\"Locked\">";
			}
			else
			{
				$locked = "<img src=\"" . $config["themes"] . $config["theme"] . "/thread.png\" alt=\"\">";
			}
			echo "<tr><td>$locked <a href=\"view.php?cat=$id&amp;pid=$filename\">$posttitle</a></td><td>$replies</td><td>$author</td><td>$date</td></tr>";
		}
		echo "</table>";
	}
	else
	{
		$ptitle = "Error - " . $config["title"];
		include($config["themes"] . $config["theme"] . "/header.html");
		echo "<div class=\"error\"><strong>Error:</strong> The category doesn't exist</div>";
	}
}
else
{
	header("Location: index.php"); exit;
}

include($config["themes"] . $config["theme"] . "/footer.html");
?>
