<?php
/*
TuxBoard forum script
Copyright (C) 2013  Colin Murphy

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

session_start();
require_once("config.php");
require_once("bbcode.php");

if ($_SESSION["tb_username"] and $_SESSION["tb_password"]) {
	if (file_exists($config["userdata"] . $_SESSION["tb_username"] . ".php")) {
		# User exists. Check if password is correct.
		include($config["userdata"] . $_SESSION["tb_username"] . ".php");
		if ($tbPassword == htmlentities(stripslashes($_SESSION["tb_password"]))) {
			# Password is correct.
			$loggedin = true;
		}
		else
		{
			# Incorrect password... destroy the session and go to the login form.
			session_destroy();
			header("Location: index.php"); exit;
		}
	}
	else
	{
		# User doesn't exist... destroy the session and go to the login form.
		session_destroy();
		header("Location: index.php"); exit;
	}
}
else
{
	# User is not logged in.
	$loggedin = false;
}


# Check if $_GET["id"] is set and user logged in
if ($_GET["id"] and $loggedin)
{
	# It is set, make it a variable with slashes stripped and anti-XSS
	# protection.
	$id = htmlentities(stripslashes($_GET["id"]), ENT_QUOTES);
}
else
{
	# Not set. Go to index.php
	header("Location: index.php");
	exit;
}

# Check if user is an admin
if (file_exists($config["userdata"] . $_SESSION["tb_username"] . ".admin")) {
	$admin = true;
}

# Check if the form is filled out
if ($_POST["subject"] and $_POST["content"])
{
	# It is filled out, make post.
	$subject = htmlentities(stripslashes($_POST["subject"]), ENT_QUOTES);
	$username = htmlentities(stripslashes($tbUsername), ENT_QUOTES);
	$content = htmlentities(stripslashes($_POST["content"]), ENT_QUOTES);
	$content = nl2br($content);
	$content = bbcode_format($content);
	$lock = htmlentities(stripslashes($_POST["lock"]), ENT_QUOTES);
	$_SESSION["username"] = $username;
	
	#=========================== incremental post numbers
	$pid = file_get_contents($config["datadir"] . $id . "/pn.txt");
	$setpid = $pid + 1;
	file_put_contents($config["datadir"] . $id . "/pn.txt", $setpid);
	
	$pid = file_get_contents($config["datadir"] . $id . "/postnumber.txt");
	$setpid = $pid + 1;
	file_put_contents($config["datadir"] . $id . "/postnumber.txt", $setpid);
	
	file_put_contents($config["userdata"] . "$username.topics", file_get_contents($config["userdata"] . "$username.topics") + 1);
	file_put_contents($config["userdata"] . "$username.posts", file_get_contents($config["userdata"] . "$username.posts") + 1);
	#============================
	
	# user ranks and user color
	$usercolor = file_get_contents($config["userdata"] . "$username.color");
	$userrank = file_get_contents($config["userdata"] . "$username.rank");
	
	$username = "<span style=\"color: $usercolor\">$username</span>";
	
	$poststyle= "<tr>
	<td class=\"info\">
	<div><strong><a href=\"profile.php?user=$tbUsername\" style=\"color:$usercolor;\">$tbUsername</a></strong></div>
	<div>$userrank</div>
	<div><img src=\"avatar.php?username=$tbUsername\" alt=\"\"></div>
	<div><small>Posted on: " . date($config["date"]) . " " . date($config["time"]) . "</small></div>
	</td>
	<td>$content</td></tr>\n";
	
	# Logging
	file_put_contents($config["postlog"], "<tr><td>" . date($config["date"]) . " " . date($config["time"]) . "</td><td>$username</td><td><a href=\"view.php?cat=$id&amp;pid=$pid\">$subject</a></td><td>" . $_SERVER["REMOTE_ADDR"] . "</td><td>" . htmlentities($_SERVER["HTTP_USER_AGENT"], ENT_QUOTES) . "</td></tr>\n" . file_get_contents($config["postlog"]));
	# END LOGGING
	
	file_put_contents($config["datadir"] . $id . "/$pid" . "_subject.txt", $subject); # Write subject
	file_put_contents($config["datadir"] . $id . "/$pid.html", $poststyle); # Write post
	file_put_contents($config["datadir"] . $id . "/$pid.author", $username); # write username
	file_put_contents($config["datadir"] . $id . "/$pid.date", date($config["date"]) . " " . date($config["time"])); # write date
	file_put_contents($config["datadir"] . $id . "/$pid.replies", "0"); # replies counter
	file_put_contents($config["datadir"] . $id . "/last.txt", "<a href=\"view.php?cat=$id&amp;pid=$pid\">$subject</a> by $username"); # Set last message
	if ($lock == true)
	{
		file_put_contents($config["datadir"] . $id . "/$pid.lock", ""); # lock topic
	}
	header("Location: view.php?cat=$id&pid=$pid");exit; # Send user to the viewtopic page
}
else
{
	# Form not filled out. Show it.
	$ptitle = "New topic - " . $config["title"];
	include($config["themes"] . $config["theme"] . "/header.html");
	echo "<h2>New topic - <a href=\"category.php?id=$id\">" . file_get_contents($config["datadir"] . $id . "/title.txt") . "</a></h2>";
?>
<form action="newtopic.php?id=<?php echo $id; ?>" method="post">
	<table>
		<tr><td><strong>Subject:</strong></td><td><input type="text" name="subject"></td></tr>
		<tr><td></td><td><input type="button" onclick="add('[b][/b]');" value="b"> <input type="button" onclick="add('[i][/i]');" value="i"> <input type="button" onclick="add('[u][/u]');" value="u"> <input type="button" onclick="add('[img][/img]');" value="img"> <input type="button" onclick="add('[code][/code]');" value="code"> </td></tr>
		<tr><td><strong>Post:</strong></td><td><textarea rows="10" cols="50" name="content" id="content"></textarea></td></tr>
		<?php if ($admin == true) {echo "<tr><td><strong>Lock topic:</strong></td><td><input type=\"checkbox\" name=\"lock\" value=\"true\"></td></tr>";	} ?>
		<tr><td>&nbsp;</td><td><input type="submit" value="Send"></td></tr>
	</table>
</form>
<?php
include($config["themes"] . $config["theme"] . "/footer.html");
}
?>
