<?php
/*
TuxBoard forum script
Copyright (C) 2013  Colin Murphy

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

session_start();
require_once("config.php");
require_once("bbcode.php");
if ($_SESSION["tb_username"] and $_SESSION["tb_password"]) {
	if (file_exists($config["userdata"] . $_SESSION["tb_username"] . ".php")) {
		# User exists. Check if password is correct.
		include($config["userdata"] . $_SESSION["tb_username"] . ".php");
		if ($tbPassword == htmlentities(stripslashes($_SESSION["tb_password"]))) {
			# Password is correct.

			$action = htmlentities(stripslashes($_GET["action"]), ENT_QUOTES);
			if (!$action) { $action = "main"; }
			
			switch ($action) {
			#------------ main page
			case "main":
				$ptitle = "User Control Panel - " . $config["title"];
				include($config["themes"] . $config["theme"] . "/header.html");
				?>
					<h2>User Control Panel</h2>
					<p>&bull; <a href="?action=avatar">Avatars</a></p>
					<p>&bull; <a href="?action=profile">Edit profile</a></p>
					<p>&bull; <a href="profile.php?user=<?php echo $tbUsername; ?>">View profile</a></p>
				<?php
				include($config["themes"] . $config["theme"] . "/footer.html");
			break;
			
			#------------ profile
			case "profile":
				$ptitle = "Editing Profile - " . $config["title"];
				include($config["themes"] . $config["theme"] . "/header.html");
				$website = htmlentities(file_get_contents($config["userdata"] . "$tbUsername.web"), ENT_QUOTES);
				$age = htmlentities(file_get_contents($config["userdata"] . "$tbUsername.age"), ENT_QUOTES);
				?>
				<div class="fright"><a href="profile.php?user=<?php echo $tbUsername; ?>">View profile</a></div>
				<h2><a href="ucp.php?action=main">UCP:</a> Edit Profile</a></h2>
				<form action="ucp.php?action=eprofile" method="post">
					<table class="forums">
						<tr><td><strong>Website:</strong></td><td><input type="text" name="website" value="<?php echo $website; ?>"></tr>
						<tr><td><strong>Age:</strong></td><td><input type="text" name="age" value="<?php echo $age; ?>"></tr>
						<tr><td colspan="2"><input type="submit" value="Save profile"></td></tr>
					</table>
				</form?
				<?php
				include($config["themes"] . $config["theme"] . "/footer.html");
			break;
			
			case "eprofile":
				if (isset($_POST["website"]) and isset($_POST["age"])) {
					$website = htmlentities(stripslashes($_POST["website"]), ENT_QUOTES);
					$age = htmlentities(stripslashes($_POST["age"]), ENT_QUOTES);
					
					# sanitize website string
					$website = str_replace(array("javascript:", "ftp:", "irc:", "ircs:", "skype:"), "", $website);
					
					# write files
					file_put_contents($config["userdata"] . "$tbUsername.web", $website);
					file_put_contents($config["userdata"] . "$tbUsername.age", $age);
					
					# redirect.
					$ptitle = $config["title"]; include($config["themes"] . $config["theme"] . "/header.html");
					echo "<meta http-equiv=\"refresh\" content=\"3; url=ucp.php?action=profile\">";
					echo "<div class=\"box\">Your profile has been updated. If your browser doesn't redirect you, <a href=\"ucp.php?action=profile\">click here</a></div>";
					include($config["themes"] . $config["theme"] . "/footer.html");
				}
				else
				{
					header("Location: ucp.php?action=profile"); exit;
				}
			break;
			
			#------------ avatars
			case "avatar":
				$ptitle = "Forum Avatar - " . $config["title"];
				include($config["themes"] . $config["theme"] . "/header.html");
				?>
					<h2><a href="ucp.php?action=main">UCP:</a> Forum Avatar</h2>
					<table class="forums">
						<tr class="toptr">
							<td>Upload &amp; Settings</td>
							<td>Current avatar</td>
						</tr>
						<tr>
							<td class="topalign">
								<p><strong>Upload</strong></p>
								<form action="ucp.php?action=uploadavatar" method="post" enctype="multipart/form-data">
									<p><input type="file" name="file"> <input type="submit" value="Upload"></p>
								</form>
								<hr>
								<p><a href="#" onclick="eraseAvatar();">Clear avatar</a></p>
							</td>
							<td class="info">
								<img src="avatar.php?username=<?php echo $tbUsername; ?>" alt="<?php echo $tbUsername; ?>'s avatar">
							</td>
						</tr>
					</table>
				<?php
				include($config["themes"] . $config["theme"] . "/footer.html");
			break;

				#----------- upload avatar
				case "uploadavatar":
					if($_FILES["file"]["name"]) {
						if(!$_FILES['file']['error']) {
							if($_FILES['file']['size'] > 1024000) {
								include($config["themes"] . $config["theme"] . "/header.html");
								echo "<div class=\"error\"><strong>Error:</strong> Image filesize is too big. <a href=\"ucp.php?action=avatar\">Go back</a></div>";exit;
								include($config["themes"] . $config["theme"] . "/footer.html");
							}
							switch ($_FILES['file']['type']) {
								# allowed file types
								case "image/png": $ext = "png"; break; # png
								case "image/gif": $ext = "gif"; break; # gif
								case "image/jpeg": $ext = "jpg"; break; #jp(e)g
								default:
									include($config["themes"] . $config["theme"] . "/header.html");
									echo "<div class=\"error\"><strong>Error:</strong> Bad filetype! <a href=\"ucp.php?action=avatar\">Go back</a></div>";exit; #zomghacker
									include($config["themes"] . $config["theme"] . "/footer.html");
								break;
							}
							# delete old avatars for username
							array_map( "unlink", glob($config["userdata"] . "avatars/$tbUsername*") );
							
							move_uploaded_file($_FILES["file"]['tmp_name'], $config["userdata"] . "avatars/$tbUsername.$ext");
							file_put_contents($config["userdata"] . "avatars/$tbUsername.txt", $config["userdata"] . "avatars/$tbUsername.$ext");
							$ptitle = $config["title"]; include($config["themes"] . $config["theme"] . "/header.html");
							echo "<meta http-equiv=\"refresh\" content=\"3; url=ucp.php?action=avatar\">";
							echo "<div class=\"box\">Avatar uploaded! If your browser doesn't redirect you, <a href=\"ucp.php?action=avatar\">click here</a></div>";
							include($config["themes"] . $config["theme"] . "/footer.html");
						}
						else
						{
							include($config["themes"] . $config["theme"] . "/header.html");
							echo "<div class=\"error\"><strong>Error:</strong> Image filesize is too big. <a href=\"ucp.php?action=avatar\">Go back</a></div>";exit;
							include($config["themes"] . $config["theme"] . "/footer.html");
						}
					}
					else
					{
						header("Location: ucp.php?action=avatar"); exit;
					}
				break;


				# Delete avatar
				case "delavatar":
					array_map( "unlink", glob($config["userdata"] . "avatars/$tbUsername*") );
					$ptitle = $config["title"]; include($config["themes"] . $config["theme"] . "/header.html");
					echo "<meta http-equiv=\"refresh\" content=\"3; url=ucp.php?action=avatar\">";
					echo "<div class=\"box\">Your avatar has been deleted. If your browser doesn't redirect you, <a href=\"ucp.php?action=avatar\">click here</a></div>";
					include($config["themes"] . $config["theme"] . "/footer.html");
				break;
				
				#----------- default
				default:
					$ptitle = "User Control Panel - error - " . $config["title"];
					include($config["themes"] . $config["theme"] . "/header.html");
					echo "<div class=\"error\"><strong>Error:</strong> Invalid UCP page! <a href=\"ucp.php?action=main\">Go back</a></div>";
					include($config["themes"] . $config["theme"] . "/footer.html");
				break;
			}
		
		}
		else
		{
			# Password is incorrect.
			session_destroy();
			header("Location: login.php"); exit;
		}
	}
	else
	{
		# User doesn't exist.
		session_destroy();
		header("Location: register.php"); exit;
	}
}
else
{
	# User is not logged in.
	header("Location: login.php"); exit;
}
?>
