<?php
/*
TuxBoard forum script
Copyright (C) 2013  Colin Murphy

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

session_start();
require_once("config.php");

if ($_SESSION["tb_username"] and $_SESSION["tb_password"]) {
	if (file_exists($config["userdata"] . $_SESSION["tb_username"] . ".php")) {
		# User exists. Check if password is correct.
		include($config["userdata"] . $_SESSION["tb_username"] . ".php");
		if ($tbPassword == htmlentities(stripslashes($_SESSION["tb_password"]))) {
			# Password is correct.
			$loggedin = true;
		}
		else
		{
			# Incorrect password... destroy the session and go to the login form.
			header("Location: index.php"); exit;
		}
	}
	else
	{
		# User doesn't exist... destroy the session and go to the login form.
		header("Location: index.php"); exit;
	}
}
else
{
	# User is not logged in.
	$loggedin = false;
}



if (isset($_GET["cat"]) and isset($_GET["pid"]))
{
	$cat = htmlentities(stripslashes($_GET["cat"]), ENT_QUOTES);
	$pid = htmlentities(stripslashes($_GET["pid"]), ENT_QUOTES);
	if (is_dir($config["datadir"] . $cat))
	{
		if (file_exists($config["datadir"] . $cat . "/$pid.html"))
		{
			if (file_exists($config["datadir"] . $cat . "/$pid" . "_subject.txt")) # Check if subject file exists
			{
				$subject = file_get_contents($config["datadir"] . $cat . "/$pid" . "_subject.txt"); # Subject file exists.
			}
			else
			{
				$subject = $pid;
			}
			if (file_exists($config["datadir"] . "$cat/$pid.lock")) {
				$replytext = "<strong>Locked</strong>";
			}
			else
			{
				$replytext = "<strong><a href=\"reply.php?cat=$cat&amp;pid=$pid\">Post Reply</a></strong>";
			}
			$ptitle = "$subject - " . $config["title"];
			include($config["themes"] . $config["theme"] . "/header.html");
			echo "<p class=\"fright\">$replytext</p><h2>$subject</h2>";
			echo "<table class=\"table post\">";
			echo file_get_contents($config["datadir"] . $cat . "/$pid.html");
			echo "</table><p class=\"right\">$replytext</p></p>";
			
			# lock/unlock stuffs
			if ($loggedin == true and file_exists($config["userdata"] . "$tbUsername.admin")) {
				if (file_exists($config["datadir"] . "$cat/$pid.lock")) {
					echo "<p><strong><a href=\"adm.php?action=lock&amp;cat=$cat&amp;pid=$pid\">Unlock topic</a></strong></p>";
				}
				else
				{
					echo "<p><strong><a href=\"adm.php?action=lock&amp;cat=$cat&amp;pid=$pid\">Lock topic</a></strong></p>";
				}
				echo "<p><strong><a href=\"adm.php?action=deltopic&amp;cat=$cat&amp;pid=$pid\">Delete topic</a></strong></p>";
			}
		}
		else
		{
			$ptitle = "Error - " . $config["title"];
			include($config["themes"] . $config["theme"] . "/header.html");
			echo "<div class=\"error\">Post doesn't exist.</div>";
		}
	}
	else
	{
		$ptitle = "Error - " . $config["title"];
		include($config["themes"] . $config["theme"] . "/header.html");
		echo "<div class=\"error\">Category doesn't exist.</div>";
	}
}
else
{
	$ptitle = "Error - " . $config["title"];
	include($config["themes"] . $config["theme"] . "/header.html");
	echo "<div class=\"error\">No category and/or post ID specified.</div>";
}
include($config["themes"] . $config["theme"] . "/footer.html");
?>
